# setup internal paths -
_PATH_TO_SRC = dirname(pathof(@__MODULE__))

# load external packages
using CSV
using DataFrames
using Dates
using Distributions
using Plots
using LinearAlgebra
using BSON
using BSON: @save

# load my codes 
include(joinpath(_PATH_TO_SRC, "Types.jl"))
include(joinpath(_PATH_TO_SRC, "Expiration.jl"))
include(joinpath(_PATH_TO_SRC, "Factory.jl"))
include(joinpath(_PATH_TO_SRC, "Lattice.jl"))
include(joinpath(_PATH_TO_SRC, "Greeks.jl"))
include(joinpath(_PATH_TO_SRC, "Files.jl"))
include(joinpath(_PATH_TO_SRC, "Decisions.jl"))
include(joinpath(_PATH_TO_SRC, "Search.jl"))